POJ 3831 & HDU 3264 Open-air shopping malls(几何)

题目链接:

POJ:http://poj.org/problem?id=3831

HDU:http://acm.hdu.edu.cn/showproblem.php?pid=3264

Description

The city of M is a famous shopping city and its open-air shopping malls are extremely attractive. During the tourist seasons, thousands of people crowded into these shopping malls and enjoy the vary-different shopping.

Unfortunately, the climate has changed little by little and now rainy days seriously affected the operation of open-air shopping malls -- it‘s obvious that nobody will have a good mood when shopping in the rain. In order to change this situation, the manager
of these open-air shopping malls would like to build a giant umbrella to solve this problem.

These shopping malls can be considered as different circles. It is guaranteed that these circles will not intersect with each other and no circles will be contained in another one. The giant umbrella is also a circle. Due to some technical reasons, the center
of the umbrella must coincide with the center of a shopping mall. Furthermore, a fine survey shows that for any mall, covering half of its area is enough for people to seek shelter from the rain, so the task is to decide the minimum radius of the giant umbrella
so that for every shopping mall, the umbrella can cover at least half area of the mall.

Input

The input consists of multiple test cases.

The first line of the input contains one integer T (1 <= T <= 10), which is the number of test cases. For each test case, there is one integer N (1 <= N <= 20) in the first line, representing the number of shopping malls.

The following N lines each contain three integers X,Y,R, representing that the mall has a shape of a circle with radius R and its center is positioned at (X, Y). X and Y are in the range of [-10000,10000] and R is a positive integer less than 2000.

Output

For each test case, output one line contains a real number rounded to 4 decimal places, representing the minimum radius of the giant umbrella that meets the demands.

Sample Input

1
2
0 0 1
2 0 1

Sample Output

2.0822

Source

Ningbo 2009

题意:

给出一些圆,选择其中一个圆的圆心为圆心,然后画一个大圆,要求大圆最少覆盖每个圆的一半面积。求最小面积。

代码如下:

#include <cstdio>
#include <cstring>
#include <cmath>
#include <iostream>
#include <algorithm>

using namespace std;
const double eps = 1e-8;
const double PI = acos(-1.0);

int sgn(double x)
{
    if(fabs(x) < eps) return 0;
    if(x < 0) return - 1;
    else return 1;
}
struct Point
{
    double x, y, r;
    Point() {}
    Point(double _x, double _y)
    {
        x = _x;
        y = _y;
    }
    Point operator -( const Point &b) const
    {
        return Point(x - b. x, y - b. y);
    }
    //叉积
    double operator ^ (const Point &b) const
    {
        return x*b. y - y*b. x;
    }
    //点积
    double operator * (const Point &b) const
    {
        return x*b. x + y*b. y;
    }
    //绕原点旋转角度B(弧度值),后x,y的变化
    void transXY(double B)
    {
        double tx = x,ty = y;
        x = tx* cos(B) - ty*sin(B);
        y = tx* sin(B) + ty*cos(B);
    }
};
Point p[47];

//*两点间距离
double dist( Point a, Point b)
{
    return sqrt((a-b)*(a- b));
}
//两个圆的公共部分面积
double Area_of_overlap(Point c1, double r1, Point c2, double r2)
{
    double d = dist(c1,c2);
    if(r1 + r2 < d + eps) return 0;
    if(d < fabs(r1 - r2) + eps)
    {
        double r = min(r1,r2);
        return PI*r*r;
    }
    double x = (d*d + r1*r1 - r2*r2)/(2*d);
    double t1 = acos(x / r1);
    double t2 = acos((d - x)/r2);
    return r1*r1*t1 + r2*r2*t2 - d*r1*sin(t1);
}

int main()
{
    double x1, y1, r1, x2, y2, r2;
    int t;
    int n;
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        for(int i = 0; i < n; i++)
        {
            scanf("%lf %lf %lf",&p[i].x,&p[i].y,&p[i].r);
        }
        double ans = 999999;
        double l, r, mid;
        for(int i = 0; i < n; i++) //枚举圆心
        {
            l = 0;
            r = 35000.0;//二分
            while(r-l > eps)//能找到
            {
                mid = (l+r)/2.0;
                int flag = 0;
                for(int j = 0; j < n; j++) // 每个点
                {
                    if(Area_of_overlap(p[i],mid,p[j],p[j].r)<p[j].r*p[j].r*PI/2.0)
                    {
                        flag = 1;//太小
                        break;
                    }
                }
                if(flag)
                    l = mid;
                else
                    r = mid;
            }
            if(l < ans)
                ans = l;
        }
        printf("%.4lf\n",ans);
    }
    return 0;
}

时间: 2024-08-25 17:05:41

POJ 3831 & HDU 3264 Open-air shopping malls(几何)的相关文章

POJ 1018 &amp; HDU 1432 Lining Up 【简单几何】

Lining Up Time Limit: 2000MS   Memory Limit: 32768K Total Submissions: 24786   Accepted: 7767 Description "How am I ever going to solve this problem?" said the pilot. Indeed, the pilot was not facing an easy task. She had to drop packages at spe

HDU 3264 Open-air shopping malls(圆相交面积+二分)

HDU 3264 Open-air shopping malls(圆相交面积+二分) ACM 题目地址:HDU 3264 Open-air shopping malls 题意: 给出一些圆,选择其中一个圆的圆心为圆心,然后画一个大圆,要求大圆最少覆盖每个圆的一半面积.求最小面积. 分析: 枚举每个点,用二分求出需要的圆,更新最小值即可. 其中用到了圆相交面积,可以参考这题: POJ 2546 Circular Area(两个圆相交面积) 代码: /* * Author: illuz <iillu

hdu 3264 Open-air shopping malls 求两圆相交

对每个圆二分半径寻找可行的最小半径,然后取最小的一个半径. 对于两圆相交就只要求到两个扇形,然后减去两个全等三角形就行了. #include<cstdio> #include<iostream> #include<cmath> #include<algorithm> using namespace std; #define pi acos(-1.0) #define eps 1e-8 #define maxn 50 int n; struct point{

hdu 3264 Open-air shopping malls(求圆相交的面积,二分)

Open-air shopping malls Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2256    Accepted Submission(s): 837 Problem Description The city of M is a famous shopping city and its open-air shopping

HDU 3264 Open-air shopping malls (两个圆的交面积+二分)

题目链接 :HDU 3264 Open-air shopping malls 题意:给出n个圆.要求一个在n个圆的圆心建一个大圆,使大圆与每一个小圆的交面积大于等于该小圆的面积的一般.求最小的大圆半径. 思路:二分大圆半径,枚举每个小圆与大圆的交面积. 注意精度问题. AC代码: #include <stdio.h> #include <math.h> #include <algorithm> const double eps=1e-6; const double PI

hdu 3264 09 宁波 现场 E - Open-air shopping malls 计算几何 二分

Description The city of M is a famous shopping city and its open-air shopping malls are extremely attractive. During the tourist seasons, thousands of people crowded into these shopping malls and enjoy the vary-different shopping. Unfortunately, the

hdu 3264 圆的交+二分

Open-air shopping malls Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1822    Accepted Submission(s): 651 Problem Description The city of M is a famous shopping city and its open-air shopping

Open-air shopping malls(二分半径,两元交面积)

http://acm.hdu.edu.cn/showproblem.php?pid=3264 Open-air shopping malls Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2139    Accepted Submission(s): 775 Problem Description The city of M is a

HDU 3264 区间内的最大最小之差

题目链接:http://poj.org/problem?id=3264 题目大意:在给定一堆牛的数量以及其高度的时候,每次给定一段区间,求这个区间内最高的牛和最矮的牛的高度之差为多少. 这道题目用线段树能快速的求解,因为此处不涉及更新,所以无需写update函数 不同于之前只定义一个tree数组,这回我们需要定义一个Max和一个Min数组分别子弟想存放较大和较小值 通过query找到区间内的最大值q,和最小值p,那么q-p便是我们所求的 1 #include <iostream> 2 #inc